Subject: Re: [RFC PATCH 00/11] an introduction of library operating system for Linux (LibOS)

From: Hajime Tazaki <[email-masked]>
Date: Tue, 31 Mar 2015 16:47:40 +0900

At Mon, 30 Mar 2015 08:41:52 +0200,
Richard Weinberger wrote:

> > one more concern on the out-of-arch-tree design is that how
> > to handle our asm-generic-based header files
> > (arch/lib/include/asm). we have been heavily used
> > 'generic-y' in the Kbuild file to reuse header files.
> 
> As noted before, libos is something in between. Maybe the asm-generic
> stuff needs some modifications to make it work for libos.

okay.

> BTW: There is something really fishy wrt to your build process.
> I did a ARCH=i386 build due to my regular kernel work and later a ARCH=lib build.
> It seems to pickup old/unrelated object files.
> After a make clean ARCH=i386 it build fine.
> 
> ---cut---
>   LIB           liblinux-4.0.0-rc5.so
> /usr/lib64/gcc/x86_64-suse-linux/4.8/../../../../x86_64-suse-linux/bin/ld: Warning: size of symbol `skb_copy_bits' changed from 10 in ./kernel/bpf/core.o to 441 in ./net/core/skbuff.o
> ./net/ipv6/fib6_rules.o: In function `fib6_rule_lookup':
> /home/rw/linux/net/ipv6/fib6_rules.c:34: multiple definition of `fib6_rule_lookup'
(snip)

right now arch/lib/Makefile isn't fully on the Kbuild
system: build file dependency is not tracked at all.

while I should learn more about Kbuild, I'd be happy if you
would suggest how the Makefile should be.

> ---cut---
> 
> While we're talking about the build process, how can I cross build libos?
> Say a i386 libos on x86_64. For UML we have use SUBARCH.
> i.e. make linux ARCH=um SUBARCH=i386

the cross build is not either implemented. if libos needs it,
I'd start to think about the design: maybe SUBARCH-like
mechanism is required.

-- Hajime